Package org.apache.sis.metadata.iso.content

# Class DefaultRangeElementDescription

Object
AbstractMetadata
ModifiableMetadata
ISOMetadata
DefaultRangeElementDescription

All Implemented Interfaces:
  `Serializable`, `Emptiable`, `LenientComparable`, `IdentifiedObject`, `RangeElementDescription`

@TitleProperty(name="name") public class DefaultRangeElementDescription extends ISOMetadata implements RangeElementDescription
Description of specific range elements. The following properties are mandatory in a well-formed metadata according ISO 19115:
`MI_RangeElementDescription` `├─name………………………………………………` Designation associated with a set of range elements. `├─definition………………………………` Description of a set of specific range elements. `└─rangeElement…………………………` Specific range elements, i.e. range elements associated with a name and their definition.

## Limitations

- Instances of this class are not synchronized for multi-threading. Synchronization, if needed, is caller's responsibility.
- Serialized objects of this class are not guaranteed to be compatible with future Apache SIS releases. Serialization support is appropriate for short term storage or RMI between applications running the same version of Apache SIS. For long term storage, use `XML` instead.

Since:
  0.3
See Also:
  - Serialized Form

Defined in the `sis-metadata` module

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class ModifiableMetadata

  `ModifiableMetadata​.State`

- ## Field Summary

  ### Fields inherited from class ISOMetadata

  `identifiers`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `DefaultRangeElementDescription()`
  Constructs an initially empty range element description.
  `DefaultRangeElementDescription(RangeElementDescription object)`
  Constructs a new instance initialized with the values from the specified metadata object.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static DefaultRangeElementDescription`
  `castOrCopy(RangeElementDescription object)`
  Returns a SIS metadata implementation with the values of the given arbitrary implementation.
  `InternationalString`
  `getDefinition()`
  Returns the description of a set of specific range elements.
  `InternationalString`
  `getName()`
  Returns the designation associated with a set of range elements.
  `Collection<Record>`
  `getRangeElements()`
  Returns the specific range elements, i.e. range elements associated with a name and their definition.
  `void`
  `setDefinition(InternationalString newValue)`
  Sets the description of a set of specific range elements.
  `void`
  `setName(InternationalString newValue)`
  Sets the designation associated with a set of range elements.
  `void`
  `setRangeElements(Collection<? extends Record> newValues)`
  Sets the specific range elements, i.e. range elements associated with a name and their definition.

  ### Methods inherited from class ISOMetadata

  `getIdentifier, getIdentifierMap, getIdentifiers, getStandard, setIdentifier, transitionTo`

  ### Methods inherited from class ModifiableMetadata

  `checkWritePermission, collectionType, copyCollection, copyList, copyMap, copySet, deepCopy, nonNullCollection, nonNullList, nonNullMap, nonNullSet, singleton, state, writeCollection, writeList, writeMap, writeSet`

  ### Methods inherited from class AbstractMetadata

  `asMap, asTreeTable, equals, equals, getInterface, hashCode, isEmpty, prune, toString`

  ### Methods inherited from class Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### DefaultRangeElementDescription

    public DefaultRangeElementDescription()
    Constructs an initially empty range element description.

  - ### DefaultRangeElementDescription

    public DefaultRangeElementDescription(RangeElementDescription object)
    Constructs a new instance initialized with the values from the specified metadata object. This is a shallow copy constructor, since the other metadata contained in the given object are not recursively copied.
    Parameters:
      `object` - the metadata to copy values from, or `null` if none.
    See Also:
      - `castOrCopy(RangeElementDescription)`

- ## Method Details

  - ### castOrCopy

    public static DefaultRangeElementDescription castOrCopy(RangeElementDescription object)
    Returns a SIS metadata implementation with the values of the given arbitrary implementation. This method performs the first applicable action in the following choices:
    - If the given object is `null`, then this method returns `null`.
    - Otherwise if the given object is already an instance of `DefaultRangeElementDescription`, then it is returned unchanged.
    - Otherwise a new `DefaultRangeElementDescription` instance is created using the copy constructor and returned. Note that this is a shallow copy operation, since the other metadata contained in the given object are not recursively copied.
    Parameters:
      `object` - the object to get as a SIS implementation, or `null` if none.
    Returns:
      a SIS implementation containing the values of the given object (may be the given object itself), or `null` if the argument was null.

  - ### getName

    public InternationalString getName()
    Returns the designation associated with a set of range elements.
    Specified by:
      `getName` in interface `RangeElementDescription`
    Returns:
      designation associated with a set of range elements, or `null`.

  - ### setName

    public void setName(InternationalString newValue)
    Sets the designation associated with a set of range elements.
    Parameters:
      `newValue` - the new name value.

  - ### getDefinition

    public InternationalString getDefinition()
    Returns the description of a set of specific range elements.
    Specified by:
      `getDefinition` in interface `RangeElementDescription`
    Returns:
      description of a set of specific range elements, or `null`.

  - ### setDefinition

    public void setDefinition(InternationalString newValue)
    Sets the description of a set of specific range elements.
    Parameters:
      `newValue` - the new definition value.

  - ### getRangeElements

    public Collection<Record> getRangeElements()
    Returns the specific range elements, i.e. range elements associated with a name and their definition.
    Specified by:
      `getRangeElements` in interface `RangeElementDescription`
    Returns:
      specific range elements.
    TODO:
      implements `Record` in order to use the annotation.

  - ### setRangeElements

    public void setRangeElements(Collection<? extends Record> newValues)
    Sets the specific range elements, i.e. range elements associated with a name and their definition.
    Parameters:
      `newValues` - the new range element values.